# -*- coding: utf-8 -*-

import uno
import unohelper

import traceback
from com.sun.star.task import XJobExecutor
from com.sun.star.awt.MessageBoxType import MESSAGEBOX
    

# Definiamo un componente con le interfacce XInitialization, XDispatch, XDispatchProvider,
# necessarie al utilizzare del "Protocol Handler"
class PyService(unohelper.Base, XJobExecutor):
    def __init__(self, ctx):
        self.ctx = ctx
        self.psm = ctx.ServiceManager
        self.tk = self.create("com.sun.star.awt.Toolkit")
        self.desktop = self.create("com.sun.star.frame.Desktop")

    def create(self, service):
        return self.psm.createInstance(service)

    # XJobExecutor
    def trigger(self, arg):
        """ All scripts are shown. """
        try:
            self.msgbox('PyService triggered with argument "{}".'.format(arg))
        except:
            self.msgbox(traceback.format_exc())

    # altri
    def msgbox(self, messaggio):
        frame = self.desktop.ActiveFrame
        if frame.ActiveFrame:
            # top window is a subdocument
            frame = frame.ActiveFrame
        win = frame.ComponentWindow
        box = self.tk.createMessageBox(win, MESSAGEBOX, 1, "Messaggio", messaggio)
        return box.execute()

# Qui registriamo il componente
g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(PyService, "giuserpe.esempio_2.impl", ("giuserpe.esempio_2.impl",),)
